import { AxiosInstance } from 'axios';
import { Query, QueryOptions } from './Query';
export declare function camelcase(str: string): string;
export declare function getCollectionName(typename: string): string;
export interface StoreOptions {
    client?: AxiosInstance;
    url?: string;
    ssr?: boolean;
}
export declare class MQStore {
    __queryCacheData: Map<any, any>;
    __queryCache: Map<any, any>;
    ssr: boolean;
    __afterInit: boolean;
    __promises: Map<any, any>;
    client: AxiosInstance;
    constructor(options?: StoreOptions);
    merge(data: unknown): any;
    deflate(data: unknown): any;
    rawRequest(path: string, method: string, variables: any): Promise<any>;
    __cacheQuery(key: string, query: any): void;
    query<T>(path: string, method: string, variables?: any, options?: QueryOptions): Query<T>;
    mutate<T>(path: string, method: string, variables?: any, optimisticUpdate?: (store: any) => void): Query<T>;
    getCollectionName: typeof getCollectionName;
    __pushPromise(promise: Promise<{}>, queryKey: string): void;
    __runInStoreContext<T>(fn: () => T): T;
    __cacheResponse(key: string, response: any): void;
}
export declare type StoreType = typeof MQStore;
