/// <reference types="react" />
import { Query } from './Query';
import { MQStore } from './MQStore';
declare var ReactNamespace: typeof import('react');
export declare type QueryLike<STORE, DATA> = (store: STORE) => Query<DATA>;
export declare function createStoreContext<STORE extends MQStore>(React: typeof ReactNamespace): import("react").Context<STORE>;
export declare function getDataFromTree<STORE extends MQStore>(tree: React.ReactElement<any>, client: STORE, renderFunction?: (tree: React.ReactElement<any>) => string): Promise<string>;
export declare type UseQueryHookOptions<STORE> = {
    store?: STORE;
    suspense?: boolean;
};
export declare type UseQueryHookResult<STORE, DATA> = {
    store: STORE;
    loading?: boolean;
    error: any;
    data: {
        [key in keyof DATA]: DATA[key];
    } | undefined;
    query: Query<DATA> | undefined;
    setQuery: (query: QueryLike<STORE, DATA>) => void;
};
export declare type UseQueryHook<STORE> = <DATA>(query?: QueryLike<STORE, DATA>, options?: UseQueryHookOptions<STORE>) => UseQueryHookResult<STORE, DATA>;
export declare function createUseQueryHook<STORE extends MQStore>(context: React.Context<STORE>, React: typeof ReactNamespace): UseQueryHook<STORE>;
export {};
