import { QueryOptions } from './Query';
import { MQStore, StoreType } from './MQStore';
declare class UserModel {
    store?: RootStore;
    relationNames?: string[];
    id: string;
    typename: string;
    email?: string;
    password?: string;
    friend_id?: string;
    get friend(): User | undefined;
    constructor(store: RootStore, data: any);
}
export declare class User extends UserModel {
    constructor(store: RootStore, data: any);
}
export interface Data {
    users?: {
        [key: string]: Omit<User, 'friend'>;
    };
}
export declare class RootStoreBase extends MQStore {
    users: import("mobx").ObservableMap<string, User>;
    kt: Map<any, any>;
    rt: Set<any>;
    constructor(options: any, data?: Data);
    queryGetUsers(variables?: {}, options?: QueryOptions): import("./Query").Query<{
        users: User[];
    }>;
    isKnownType(typename: string): boolean;
    isRootType(typename: string): boolean;
    getTypeDef(typename: string): any;
}
export declare class RootStore extends RootStoreBase {
    constructor(options: StoreType, data?: Data);
}
export {};
