# MSTQ

Generate typescript mst models and a react client to query your json rpc api

## Installation

```bash
yarn add mstq mobx mobx-react mobx-state-tree axios react react-dom
```

## Config

MSTQ requires a cosmiconfig file see https://github.com/davidtheclark/cosmiconfig

The options are as in typescript types

```ts
type Types =
  | 'int'
  | 'string'
  | 'id'
  | 'boolean'
  | 'ref'
  | 'typename'
  | 'ref[]'
  | 'int[]'
  | 'string[]'
  | 'date'
  | 'json'

interface Models {
  [key: string]: {
    [key: string]: [Types, string?]
  }
}

interface Actions {
  [key: string]: {
    [key: string]: {
      returnType: string
      type: 'query' | 'mutation'
      args: {
        [key: string]: {
          type: string
          required: boolean
        }
      }
    }
  }
}

interface Options {
  out?: string
  force?: boolean
  actions?: Actions
  models: Models
}
```
